using Newtonsoft.Json;
using System;
using System.Collections;
using System.Numerics;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.IO;
using System.Reflection;
using System.Security.Cryptography.X509Certificates;
using GrapeCity.Documents.Excel;
using GrapeCity.Documents.Excel.Forms;
using GrapeCity.Documents.Excel.Expressions;
using GrapeCity.Documents.Excel.Drawing;
using System.Globalization;
using System.Text.RegularExpressions;

namespace GrapeCity.Documents.Excel.Examples.Templates.DataSource.JsonFile
{
    class Program
    {
        static void Main(string[] args)
        {
					//create a new workbook
		var workbook = new GrapeCity.Documents.Excel.Workbook();
		
		//Load template file Template_FamilyInfo.xlsx from resource
		var templateFile = GetResourceStream("xlsx\\TemplateExcel.xlsx");
		workbook.Open(templateFile);
		
		//Get data from json file
		string jsonText = string.Empty;
		using (Stream stream = GetResourceStream("TemplateData.json"))
		using (StreamReader reader = new StreamReader(stream))
		{
		    jsonText = reader.ReadToEnd();
		}
		// Create a JsonDataSource
		var datasource = new JsonDataSource(jsonText);
		
		//Add data source
		workbook.AddDataSource("proposal", datasource);
		//Invoke to process the template
		workbook.ProcessTemplate();
		        
		// Save to an excel file
		workbook.Save("JsonFile.xlsx");

        }

		static Stream GetResourceStream(string resourcePath)
        {
            string resource = "JsonFile.Resource." + resourcePath.Replace("\\", ".");
            var assembly = typeof(Program).GetTypeInfo().Assembly;
            return assembly.GetManifestResourceStream(resource);
        }

    }
}